Package org.gradle.api.plugins

## Class JavaPluginConvention

- java.lang.Object
- - org.gradle.api.plugins.JavaPluginConvention

-     public abstract class JavaPluginConvention
      extends java.lang.Object

  Is mixed into the project when applying the `JavaBasePlugin` or the `JavaPlugin`.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `JavaPluginConvention​()` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `abstract java.io.File` | `getDocsDir​()` | Returns a file pointing to the root directory supposed to be used for all docs.
    `abstract java.lang.String` | `getDocsDirName​()` | The name of the docs directory.
    `abstract org.gradle.api.internal.project.ProjectInternal` | `getProject​()` |
    `abstract JavaVersion` | `getSourceCompatibility​()` | Returns the source compatibility used for compiling Java sources.
    `abstract SourceSetContainer` | `getSourceSets​()` | The source sets container.
    `abstract JavaVersion` | `getTargetCompatibility​()` | Returns the target compatibility used for compiling Java sources.
    `abstract java.io.File` | `getTestReportDir​()` | Returns a file pointing to the root directory to be used for reports.
    `abstract java.lang.String` | `getTestReportDirName​()` | The name of the test reports directory.
    `abstract java.io.File` | `getTestResultsDir​()` | Returns a file pointing to the root directory of the test results.
    `abstract java.lang.String` | `getTestResultsDirName​()` | The name of the test results directory.
    `abstract Manifest` | `manifest​()` | Creates a new instance of a `Manifest`.
    `abstract Manifest` | `manifest​(groovy.lang.Closure closure)` | Creates and configures a new instance of a `Manifest`.
    `abstract Manifest` | `manifest​(Action<? super Manifest> action)` | Creates and configures a new instance of a `Manifest`.
    `abstract void` | `setDocsDirName​(java.lang.String docsDirName)` |
    `abstract void` | `setSourceCompatibility​(java.lang.Object value)` | Sets the source compatibility used for compiling Java sources.
    `abstract void` | `setSourceCompatibility​(JavaVersion value)` | Sets the source compatibility used for compiling Java sources.
    `abstract void` | `setTargetCompatibility​(java.lang.Object value)` | Sets the target compatibility used for compiling Java sources.
    `abstract void` | `setTargetCompatibility​(JavaVersion value)` | Sets the target compatibility used for compiling Java sources.
    `abstract void` | `setTestReportDirName​(java.lang.String testReportDirName)` |
    `abstract void` | `setTestResultsDirName​(java.lang.String testResultsDirName)` |
    `abstract java.lang.Object` | `sourceSets​(groovy.lang.Closure closure)` | Configures the source sets of this project.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### JavaPluginConvention

          public JavaPluginConvention​()

  - ### Method Detail

    - #### sourceSets

          public abstract java.lang.Object sourceSets​(groovy.lang.Closure closure)

      Configures the source sets of this project.

      The given closure is executed to configure the `SourceSetContainer`. The `SourceSetContainer` is passed to the closure as its delegate.

      See the example below how `SourceSet` 'main' is accessed and how the `SourceDirectorySet` 'java' is configured to exclude some package from compilation.

           apply plugin: 'java'

           sourceSets {
             main {
               java {
                 exclude 'some/unwanted/package/**'
               }
             }
           }

      Parameters:
        `closure` - The closure to execute.
      Returns:
        NamedDomainObjectContainer<org.gradle.api.tasks.SourceSet>

    - #### getDocsDir

          public abstract java.io.File getDocsDir​()

      Returns a file pointing to the root directory supposed to be used for all docs.

    - #### getTestResultsDir

          public abstract java.io.File getTestResultsDir​()

      Returns a file pointing to the root directory of the test results.

    - #### getTestReportDir

          public abstract java.io.File getTestReportDir​()

      Returns a file pointing to the root directory to be used for reports.

    - #### getSourceCompatibility

          public abstract JavaVersion getSourceCompatibility​()

      Returns the source compatibility used for compiling Java sources.

    - #### setSourceCompatibility

          public abstract void setSourceCompatibility​(java.lang.Object value)

      Sets the source compatibility used for compiling Java sources.
      Parameters:
        `value` - The value for the source compatibility as defined by `JavaVersion.toVersion(Object)`

    - #### setSourceCompatibility

          public abstract void setSourceCompatibility​(JavaVersion value)

      Sets the source compatibility used for compiling Java sources.
      Parameters:
        `value` - The value for the source compatibility

    - #### getTargetCompatibility

          public abstract JavaVersion getTargetCompatibility​()

      Returns the target compatibility used for compiling Java sources.

    - #### setTargetCompatibility

          public abstract void setTargetCompatibility​(java.lang.Object value)

      Sets the target compatibility used for compiling Java sources.
      Parameters:
        `value` - The value for the target compatibility as defined by `JavaVersion.toVersion(Object)`

    - #### setTargetCompatibility

          public abstract void setTargetCompatibility​(JavaVersion value)

      Sets the target compatibility used for compiling Java sources.
      Parameters:
        `value` - The value for the target compatibility

    - #### manifest

          public abstract Manifest manifest​()

      Creates a new instance of a `Manifest`.

    - #### manifest

          public abstract Manifest manifest​(groovy.lang.Closure closure)

      Creates and configures a new instance of a `Manifest`. The given closure configures the new manifest instance before it is returned.
      Parameters:
        `closure` - The closure to use to configure the manifest.

    - #### manifest

          public abstract Manifest manifest​(Action<? super Manifest> action)

      Creates and configures a new instance of a `Manifest`.
      Parameters:
        `action` - The action to use to configure the manifest.
      Since:
        3.5

    - #### getDocsDirName

          public abstract java.lang.String getDocsDirName​()

      The name of the docs directory. Can be a name or a path relative to the build dir.

    - #### setDocsDirName

          public abstract void setDocsDirName​(java.lang.String docsDirName)

    - #### getTestResultsDirName

          public abstract java.lang.String getTestResultsDirName​()

      The name of the test results directory. Can be a name or a path relative to the build dir.

    - #### setTestResultsDirName

          public abstract void setTestResultsDirName​(java.lang.String testResultsDirName)

    - #### getTestReportDirName

          public abstract java.lang.String getTestReportDirName​()

      The name of the test reports directory. Can be a name or a path relative to `ReportingExtension.getBaseDir()`.

    - #### setTestReportDirName

          public abstract void setTestReportDirName​(java.lang.String testReportDirName)

    - #### getSourceSets

          public abstract SourceSetContainer getSourceSets​()

      The source sets container.

    - #### getProject

          public abstract org.gradle.api.internal.project.ProjectInternal getProject​()